﻿Imports System.Collections.Generic
Imports System.Text
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Reflection
Imports System.IO
Public Class clsReadMetaData
    'Code found at the following URL:
    'http://kellyschronicles.wordpress.com/2011/09/01/get-or-write-image-metadata-with-vb-net/
    Public Function ReadEXIFMetadata(ByVal filepath As String) As ImageMetadata
        Dim fs As New FileStream(filepath, FileMode.Open, FileAccess.Read)
        Dim image__1 As Image = Image.FromStream(fs)
        Dim imagePropertyItems As PropertyItem() = image__1.PropertyItems
        Dim imageMetadata As New ImageMetadata()
        For Each pi As PropertyItem In imagePropertyItems
            Select Case CType(pi.Id, EXIFProperty)
                Case EXIFProperty.Title
                    imageMetadata.Title = Encoding.Unicode.GetString(pi.Value)
                    'imageMetadata.Title = Encoding.UTF32.GetString(pi.Value)
                    Exit Select
                Case EXIFProperty.Author
                    imageMetadata.Author = Encoding.Unicode.GetString(pi.Value)
                    'imageMetadata.Author = Encoding.UTF8.GetString(pi.Value)
                    Exit Select
                Case EXIFProperty.Keywords
                    imageMetadata.Keywords = Encoding.Unicode.GetString(pi.Value)
                    MsgBox("Keywords ID = " & pi.Id, MsgBoxStyle.Information)
                    'imageMetadata.Keywords = Encoding.UTF8.GetString(pi.Value)
                    Exit Select
                Case EXIFProperty.Comments
                    imageMetadata.Comments = Encoding.Unicode.GetString(pi.Value)
                    'imageMetadata.Comments = Encoding.UTF8.GetString(pi.Value)
                    Exit Select
                Case Else
                    Exit Select
            End Select
        Next
        fs.Close()
        Return imageMetadata
    End Function

    Public Sub SaveEXIFMetadata(ByVal image As Image, ByVal metadata As ImageMetadata, ByVal filepath As String)
        SaveEXIFMetadataProperty(image, EXIFProperty.Title, metadata.Title, filepath)
        SaveEXIFMetadataProperty(image, EXIFProperty.Author, metadata.Author, filepath)
        SaveEXIFMetadataProperty(image, EXIFProperty.Keywords, metadata.Keywords, filepath)
        SaveEXIFMetadataProperty(image, EXIFProperty.Comments, metadata.Comments, filepath)
    End Sub
    Private Sub SaveEXIFMetadataProperty(ByVal image As Image, ByVal [property] As EXIFProperty, ByVal propertyValue As String, ByVal filepath As String)
        Dim propertyItem As PropertyItem = CreatePropertyItem()
        propertyItem.Id = CInt([property])
        ' Type=1 means Array of Bytes.
        propertyItem.Type = 2
        propertyItem.Len = propertyValue.Length
        'propertyItem.Value = Encoding.Unicode.GetBytes(propertyValue)
        propertyItem.Value = Encoding.UTF8.GetBytes(propertyValue)
        image.SetPropertyItem(propertyItem)
        image.Save(filepath)
    End Sub
    Private Function CreatePropertyItem() As PropertyItem
        Dim ci As System.Reflection.ConstructorInfo = GetType(PropertyItem).GetConstructor(BindingFlags.NonPublic Or BindingFlags.Instance Or BindingFlags.[Public], Nothing, New Type() {}, Nothing)
        Return DirectCast(ci.Invoke(Nothing), PropertyItem)
    End Function
    Public Enum EXIFProperty
        Title = 40091
        Author = 40093
        Keywords = 40094
        Comments = 40092
    End Enum
End Class
