﻿Imports System.IO
Imports Microsoft.Win32
Imports System.Windows.Forms
Imports Outlook = Microsoft.Office.Interop.Outlook
Imports System.Drawing.Imaging
Imports geoTagPhotos2.clsReadMetaData
Imports System.Text
Imports System.Drawing
Imports Shell32
Imports System.Data.OleDb
Imports ESRI.ArcGIS.Geodatabase
Imports ESRI.ArcGIS.Carto

Public Structure geoTaggedInfo
    Public latitude As Double
    Public longitude As Double
    Public description As String
    Public keywords As String
    Public taggedByUserName As String
    Public tageedByFullName As String
    Public dateTagged As Date
    Public filename As String
    Public fullpath As String
    Public taggedByDepartment As String
    Public taggedByDivision As String
    Public taggedByWorkgroup As String
End Structure

Public Structure oLookContactInfo
    Public username As String
    Public fullName As String
    Public division As String
    Public department As String
    Public workgroup As String
End Structure
Module usrFunctions
    Sub globalErrorHandler(ByVal ex As Exception)
        'log the error
        Dim strMsg As String = ""
        strMsg += "ERROR: " + vbCrLf + vbCrLf
        strMsg += ex.Message + vbCrLf + vbCrLf


        ''display the error
        'If strMsg.Contains("Illegal address") Then
        '    Exit Sub
        'End If


        strMsg += "TYPE OF ERROR: " + vbCrLf + vbCrLf & ex.GetType().FullName + vbCrLf + vbCrLf
        'strMsg += "Source: " & ex.Source + vbCrLf
        strMsg += "STACKTRACE: " & ex.StackTrace + vbCrLf + vbCrLf
        strMsg += "TARGETSITE: " + ex.TargetSite.ToString & vbCrLf


        If Not ex.InnerException Is Nothing Then
            strMsg += "Inner Exception: " & vbCrLf
            strMsg += ex.InnerException.Message + vbCrLf
            strMsg += "GetType: " & ex.InnerException.GetType().FullName + vbCrLf
            strMsg += "Source: " & ex.InnerException.Source + vbCrLf
            strMsg += "StackTrace: " & ex.InnerException.StackTrace + vbCrLf
            strMsg += "TargetSite: " + ex.InnerException.TargetSite.ToString & vbCrLf
        End If

        MsgBox(strMsg, MsgBoxStyle.Critical, "An error was encountered..")
        WriteToErrorLog(ex.GetType().FullName, ex.StackTrace, ex.Message)

    End Sub

    '*************************************************************
    'NAME:          WriteToErrorLog
    'PURPOSE:       Open or create an error log and submit error message
    'PARAMETERS:    msg - message to be written to error file
    '               stkTrace - stack trace from error message
    '               title - title of the error file entry
    'RETURNS:       Nothing
    '*************************************************************
    Public Sub WriteToErrorLog(ByVal msg As String, ByVal stkTrace As String, ByVal title As String)

        'check the file
        Dim fs As IO.FileStream = New IO.FileStream("S:\SHARDATA\Environmental Services (ENVS)\GIS\errlog.txt", FileMode.OpenOrCreate, FileAccess.ReadWrite)
        Dim s As IO.StreamWriter = New StreamWriter(fs)
        s.Close()
        fs.Close()

        'log it
        Dim fs1 As IO.FileStream = New FileStream("S:\SHARDATA\Environmental Services (ENVS)\GIS\errlog.txt", FileMode.Append, FileAccess.Write)
        Dim s1 As StreamWriter = New StreamWriter(fs1)
        s1.Write("ERROR DESCRIPTION: " & vbTab & title & vbCrLf)
        s1.Write("TYPE OF ERROR: " & vbTab & vbTab & msg & vbCrLf)
        s1.Write("STACK TRACE: " & vbTab & vbTab & Trim(stkTrace) & vbCrLf)
        s1.Write("USERNAME: " & vbTab & vbTab & System.Environment.UserName & vbCrLf)
        s1.Write("DATE/TIME: " & vbTab & vbTab & DateTime.Now.ToString() & vbCrLf)
        s1.Write("===========================================================================================" & vbCrLf)
        s1.Write("")
        s1.Close()
        fs1.Close()

    End Sub

    Sub convertDec2CoordAndBytes(ByVal dec As Decimal, ByRef coord() As UInt32, ByRef vBytes() As Byte)

        Dim degs As UInt32 = Decimal.Floor(dec)
        Dim mm As Decimal = 60 * (dec - degs)
        Dim mins As UInt32 = Decimal.Floor(mm)
        Dim ss As Integer = 60 * (mm - mins)
        Dim secs As UInt32 = Decimal.Round(ss)

        ' convert decimal into coords
        coord(0) = degs
        coord(1) = 1
        coord(2) = mins
        coord(3) = 1
        coord(4) = secs
        coord(5) = 1

        ' convert coords into bytes
        Dim bytes() As Byte
        For i = 0 To 5
            bytes = BitConverter.GetBytes(coord(i))
            For j = 0 To 3
                vBytes(j + (4 * i)) = bytes(j)
            Next j
        Next i

    End Sub

    Function getOutlookName() As oLookContactInfo
        Try
            Dim oLookInfo As New oLookContactInfo
            Dim theUser As String
            Dim oOutlook As New Microsoft.Office.Interop.Outlook.ApplicationClass
            Dim oNS As Microsoft.Office.Interop.Outlook.NameSpace
            Dim fullName As String = Nothing
            Dim theEmail As String

            oNS = oOutlook.GetNamespace("mapi")

            ' Get the Global Address List.
            Dim oALs As Microsoft.Office.Interop.Outlook.AddressLists = oNS.AddressLists
            Dim oGal As Microsoft.Office.Interop.Outlook.AddressList = oALs.Item("Global Address List")

            ' Get all the entries.
            Dim oEntries As Microsoft.Office.Interop.Outlook.AddressEntries = oGal.AddressEntries

            theUser = System.Environment.UserName
            theEmail = String.Concat(theUser, "@co.snohomish.wa.us")

            Dim loDummyMsg As Outlook.MailItem
            loDummyMsg = oOutlook.CreateItem(Outlook.OlItemType.olMailItem)

            Dim loAddress As Microsoft.Office.Interop.Outlook.Recipient = loDummyMsg.Recipients.Add(theEmail)
            Dim oContact As Outlook.ExchangeUser
            Dim oContactItem As Outlook.ContactItem

            loAddress.Resolve()
            oContact = loAddress.AddressEntry.GetExchangeUser
            oContactItem = loAddress.AddressEntry.GetContact

            fullName = oContact.FirstName & " " & oContact.LastName

            oLookInfo.fullName = fullName
            oLookInfo.username = theUser
            oLookInfo.department = oContact.CompanyName
            oLookInfo.division = oContact.Department
            oLookInfo.workgroup = oContact.OfficeLocation
            Return oLookInfo

            oNS = Nothing
            oGal = Nothing
            oALs = Nothing
            loDummyMsg = Nothing
            oContact = Nothing
            loAddress = Nothing
        Catch ex As Exception
            globalErrorHandler(ex)
            Return Nothing
        End Try
    End Function

    Function isOutLookInstalled() As Boolean
        Try
            Dim oApp As Object = CreateObject("Outlook.Application")
            Return True
            oApp = Nothing
        Catch
            Return False
        End Try
    End Function

    Sub fillCheckListboxFromFile(ByRef theControl As CheckedListBox)
        Dim exifTagFile As String = "P:\exifTagList.txt"
        Dim fileContents As String
        Dim fileExists As Boolean
        Dim exifTags As String()

        Try
            fileExists = My.Computer.FileSystem.FileExists(exifTagFile)

            If fileExists Then
                fileContents = My.Computer.FileSystem.ReadAllText(exifTagFile)
                exifTags = Split(fileContents, ",")

                theControl.Items.Clear()

                If Not String.IsNullOrEmpty(fileExists) Then
                    Dim iPos As Integer
                    For Each Item As String In exifTags
                        iPos = checkListBoxItemExists(Trim(Item), theControl)
                        If iPos < 0 Then
                            theControl.Items.Add(Trim(Item))
                        Else
                            theControl.SetItemChecked(iPos, True)
                        End If
                    Next
                Else
                    theControl.Items.Clear()
                    ' The user's personal Exif Tag List doesn't exist so create
                    ' a blank file
                    My.Computer.FileSystem.WriteAllText(exifTagFile, String.Empty, False)
                End If
            Else
                theControl.Items.Clear()
            End If
        Catch ex As Exception
            globalErrorHandler(ex)
            theControl.Items.Clear()
        End Try
    End Sub

    Sub updateExifTagsFromPhoto(ByVal tagList As String, ByRef theControl As CheckedListBox)
        Dim imgTagList As String() = Split(tagList, ",")
        Dim newTagList As New Collection
        Dim itemNum As Integer

        Try
            theControl.Items.Clear()
            fillCheckListboxFromFile(theControl)

            ' Step through all tags already in the image and see if the tag already
            ' is part of the user's tag list. If so, check it; if not, add it to the
            ' list to be added
            For Each Item As String In imgTagList
                itemNum = checkListBoxItemExists(Trim(Item.ToString), theControl)

                Select Case itemNum
                    Case Is >= 0
                        theControl.SetItemChecked(itemNum, True)
                    Case Else
                        newTagList.Add(Trim(Item))
                End Select
            Next

            ' Now add any new tags and check them
            If newTagList.Count > 0 Then
                For Each Item As String In newTagList
                    theControl.Items.Add(Item, True)
                Next
            End If
        Catch ex As Exception
            globalErrorHandler(ex)
        End Try
    End Sub
    Function checkListBoxItemExists(ByVal theItem As String, ByRef theControl As CheckedListBox) As Integer
        Dim theResult As Integer = -1

        Try
            For index As Integer = 0 To theControl.Items.Count - 1
                If StrComp(theControl.Items.Item(index).ToString, theItem, CompareMethod.Text) = 0 Then
                    theResult = index
                End If
            Next index

            'For Each Item As String In theControl.Items
            'If StrComp(Item.ToString, theItem, CompareMethod.Text) = 0 Then
            'theResult = True
            'End If
            'Next

            Return theResult
        Catch ex As Exception
            globalErrorHandler(ex)
            Return theResult
        End Try
    End Function
    Public Function ReadEXIFMetadata(ByVal filepath As String) As ImageMetadata
        Dim fs As New FileStream(filepath, FileMode.Open, FileAccess.Read)
        Dim image__1 As Image = Image.FromStream(fs)
        Dim imagePropertyItems As PropertyItem() = image__1.PropertyItems
        Dim imageMetadata As New ImageMetadata()
        For Each pi As PropertyItem In imagePropertyItems
            Select Case CType(pi.Id, EXIFProperty)
                Case EXIFProperty.Title
                    imageMetadata.Title = Encoding.Unicode.GetString(pi.Value)
                    'imageMetadata.Title = Encoding.UTF32.GetString(pi.Value)
                    Exit Select
                Case EXIFProperty.Author
                    imageMetadata.Author = Encoding.Unicode.GetString(pi.Value)
                    'imageMetadata.Author = Encoding.UTF8.GetString(pi.Value)
                    Exit Select
                Case EXIFProperty.Keywords
                    imageMetadata.Keywords = Encoding.Unicode.GetString(pi.Value)
                    'imageMetadata.Keywords = Encoding.UTF8.GetString(pi.Value)
                    Exit Select
                Case EXIFProperty.Comments
                    imageMetadata.Comments = Encoding.Unicode.GetString(pi.Value)
                    'imageMetadata.Comments = Encoding.UTF8.GetString(pi.Value)
                    Exit Select
                Case Else
                    Exit Select
            End Select
        Next
        fs.Close()
        Return imageMetadata
    End Function

    Public Function ReadFileAttributes(ByVal fInfo As FileInfo) As String

        Dim shell As New Shell32.Shell
        Dim objFolder As Shell32.Folder
        Dim items As Shell32.FolderItems
        Try
            objFolder = shell.NameSpace(fInfo.Directory.FullName)
            items = objFolder.Items
            Return objFolder.GetDetailsOf(items.Item(fInfo.Name), 18)
        Catch ex As Exception
            Return "Caught Exception in Tags" 'exception..cannot find the tags
        End Try

    End Function

    Function getTagListFromListBox(ByRef theControl As CheckedListBox) As String
        Dim theNewTagList As String = Nothing
        Dim i As Integer

        Try
            ' Compile all tags into a comma delimited string
            For i = 0 To theControl.Items.Count - 1
                If theControl.GetItemCheckState(i) = CheckState.Checked Then
                    theNewTagList = String.Concat(theNewTagList, theControl.Items(i).ToString & ",")
                End If
            Next i

            theNewTagList = Mid(theNewTagList, 1, Len(theNewTagList) - 1)
            Return theNewTagList
        Catch ex As Exception
            globalErrorHandler(ex)
            Return String.Empty
        End Try
    End Function
    Public Function ReadFileTags(ByVal theFilePath As String) As String
        Dim theFileName As String = IO.Path.GetFileName(theFilePath)
        Dim theFolderPath As String = IO.Path.GetDirectoryName(theFilePath)

        Dim shl As Shell32.Shell = New Shell32.ShellClass()
        Dim dir As Shell32.Folder = shl.[NameSpace](theFolderPath)
        Dim itm As Shell32.FolderItem = dir.Items().Item(theFileName)
        Dim itm2 As Shell32.ShellFolderItem = DirectCast(itm, Shell32.ShellFolderItem)
        'Dim prop As String = DirectCast(itm2.ExtendedProperty("{F29F85E0-4FF9-1068-AB91-08002B27B3D9} 5"), String)
        Dim theResults As Object
        Dim kWords As String = String.Empty
        Dim kWord As String
        theResults = itm2.ExtendedProperty("{F29F85E0-4FF9-1068-AB91-08002B27B3D9} 5")

        If TypeOf theResults Is Array Then
            For Each kWord In theResults
                kWords = String.Concat(kWords, kWord & ",")
            Next
            Return Left(kWords, Len(kWords) - 1)
        Else
            Return theResults
        End If
        'Return prop
    End Function

    Public Sub addPhotoToDatabase(ByVal theGTagInfo As geoTaggedInfo)
        Dim connAccess As OleDbConnection
        Dim da As OleDbDataAdapter
        Dim cmd As OleDbCommandBuilder
        Dim ds As Data.DataSet
        Dim strConn As String

        Try
            strConn = "Provider = Microsoft.ACE.OLEDB.12.0;"
            strConn += "Data Source = G:\PublicWk\geoTagging\pwPhotoDatabaseTest.accdb"

            connAccess = New OleDbConnection(strConn)

            da = New OleDbDataAdapter("Select * from tblGeotaggedPhotos", connAccess)
            cmd = New OleDbCommandBuilder(da)
            ds = New Data.DataSet("tblGeotaggedPhotos")

            da.Fill(ds, "tblGeotaggedPhotos")

            ' To add a new record
            Dim dr As Data.DataRow = ds.Tables(0).NewRow

            With dr
                .Item("Latitude") = theGTagInfo.latitude
                .Item("Longitude") = theGTagInfo.longitude
                .Item("Descrip") = theGTagInfo.description
                .Item("Keywords") = theGTagInfo.keywords
                .Item("GeotaggedBy") = theGTagInfo.taggedByUserName
                .Item("DateGeotagged") = theGTagInfo.dateTagged
                .Item("FileName") = theGTagInfo.filename
                .Item("FullPath") = theGTagInfo.fullpath
            End With

            ds.Tables(0).Rows.Add(dr)
            da.Update(ds, "tblGeotaggedPhotos")
            ds.AcceptChanges()
        Catch ex As Exception
            globalErrorHandler(ex)
        End Try
    End Sub

    Public Sub addPhotoToGeoDatabase(ByVal theGTagInfo As geoTaggedInfo)
        Try
            Dim ptable As ITable
            Dim dbPath As String = "G:\PublicWk\geoTagging\pwPhotoDatabaseTest.gdb"

            ' Create a file geodatabase workspace factory.
            Dim factoryType As Type = Type.GetTypeFromProgID("esriDataSourcesGDB.FileGDBWorkspaceFactory")

            Dim WorkspaceFactory As IWorkspaceFactory = New ESRI.ArcGIS.DataSourcesGDB.FileGDBWorkspaceFactory
            Dim Workspace As IFeatureWorkspace = CType(WorkspaceFactory.OpenFromFile(dbPath, 0), IFeatureWorkspace)

            ' Cast the workspace to the IWorkspaceEdit2 interface.
            Dim workspaceEdit As IWorkspaceEdit = CType(workspace, IWorkspaceEdit)

            ' Start an edit session. An undo/redo stack isn't necessary in this case.
            workspaceEdit.StartEditing(False)

            ' Start an edit operation.
            workspaceEdit.StartEditOperation()
            ptable = workspace.OpenTable("tblGeotaggedPhotos")

            ' Create a row. The row's attribute values should be set here and if
            ' a feature is being created, the shape should be set as well.
            Dim row As IRow = ptable.CreateRow()
            row.Value(ptable.FindField("Latitude")) = theGTagInfo.latitude
            row.Value(ptable.FindField("Longitude")) = theGTagInfo.longitude
            row.Value(ptable.FindField("Descrip")) = theGTagInfo.description
            row.Value(ptable.FindField("Keywords")) = theGTagInfo.keywords
            row.Value(ptable.FindField("gTagByUser")) = theGTagInfo.taggedByUserName
            row.Value(ptable.FindField("gTagByFullName")) = theGTagInfo.tageedByFullName
            row.Value(ptable.FindField("gTagDate")) = theGTagInfo.dateTagged
            row.Value(ptable.FindField("FileName")) = theGTagInfo.filename
            row.Value(ptable.FindField("FullPath")) = theGTagInfo.fullpath
            row.Value(ptable.FindField("gTagDept")) = theGTagInfo.taggedByDepartment
            row.Value(ptable.FindField("gTagDivision")) = theGTagInfo.taggedByDivision
            row.Value(ptable.FindField("gTagWorkgroup")) = theGTagInfo.taggedByWorkgroup
            row.Store()

            ' Save the edit operation. To cancel an edit operation, the AbortEditOperation
            ' method can be used.
            workspaceEdit.StopEditOperation()

            ' Stop the edit session. The saveEdits parameter indicates the edit session
            ' will be committed.
            workspaceEdit.StopEditing(True)
        Catch ex As Exception
            globalErrorHandler(ex)
        End Try
    End Sub
End Module
