﻿Imports System.Windows.Forms
Imports System.IO
Public Class frmEditExifTags

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        Dim exifTagFile As String = "P:\exifTagList.txt"
        Dim theNewTagList As String = Nothing
        Dim fileExists As Boolean
        Dim theForm As frmPhotoDlg

        Try
            theForm = System.Windows.Forms.Application.OpenForms(0)

            ' Compile all tags into a comma delimited string
            For Each Item As String In Me.clstExifTags.Items
                theNewTagList = String.Concat(theNewTagList, Item.ToString & ",")
            Next

            theNewTagList = Mid(theNewTagList, 1, Len(theNewTagList) - 1)
            fileExists = My.Computer.FileSystem.FileExists(exifTagFile)

            ' Finally, delete previous version and create a new file
            If fileExists Then My.Computer.FileSystem.DeleteFile(exifTagFile)
            File.WriteAllText(exifTagFile, theNewTagList)

            Me.DialogResult = System.Windows.Forms.DialogResult.OK
            Me.Close()
        Catch ex As Exception
            globalErrorHandler(ex)
        End Try
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub cmdAddTag_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdAddTag.Click
        Dim theNewTag As String
        Try
            theNewTag = InputBox("Enter your tag:", "Add New Tag")
            If Len(theNewTag) > 0 Then Me.clstExifTags.Items.Add(theNewTag)
        Catch ex As Exception
            globalErrorHandler(ex)
        End Try
    End Sub

    Private Sub frmEditExifTags_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        fillCheckListboxFromFile(Me.clstExifTags)
    End Sub

    Private Sub clstExifTags_Validated(ByVal sender As Object, ByVal e As System.EventArgs) Handles clstExifTags.Validated
        'Disable the "Delete Tag" button if no items are checked
        If Me.clstExifTags.SelectedItems.Count = 0 Then
            Me.cmdDeleteTag.Enabled = False
        Else
            Me.cmdDeleteTag.Enabled = True
        End If
    End Sub

    Private Sub cmdDeleteTag_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdDeleteTag.Click
        Dim i As Integer
        Dim items2Remove As New ArrayList()

        For i = 0 To Me.clstExifTags.Items.Count - 1
            If Me.clstExifTags.GetItemCheckState(i) = CheckState.Checked Then
                items2Remove.Add(i)
            End If
        Next

        For i = items2Remove.Count - 1 To 0 Step -1
            Me.clstExifTags.Items.RemoveAt(items2Remove(i))
        Next
    End Sub
End Class
